//Vodiace čiary na začiatku a konci sadzobného obrazca podľa zarážky odseku
//
//(c) JP, verzia 2015.01.27
//
//Globálne premenné
var gZarazkyOdseku=12;

if (app.documents.length != 0){
 if (app.selection.length > 0){
  switch(app.selection[0].constructor.name){
   case "Rectangle":
   case "Oval":
   case "Polygon":
   case "GraphicLine":
   case "Group":
   case "TextFrame":
   case "Button":
    ZobrazDialog();
    break;
   default:
    alert("Prosím vyberte objekt a skúste to znova.");
    break;
  }
 }
 else{
  alert("Prosím vyberte objekt a skúste to znova.");
 }
}
else{
 alert("Prosím otvorte dokument, vyberte objekt, a skúste to znova.");
}
 
function ZobrazDialog(){
 var Dokument=app.activeDocument;
 //Odpamätanie pôvodných nastavení
 var PovodneNastavenia=Dokument.viewPreferences.rulerOrigin;
 var PovodnaXJednotka=Dokument.viewPreferences.horizontalMeasurementUnits;
 var PovodnaYJednotka=Dokument.viewPreferences.verticalMeasurementUnits;
 var PovodnaTahJednotka=app.viewPreferences.strokeMeasurementUnits;
 //Nastavenie jednotiek na pt
 Dokument.viewPreferences.rulerOrigin=RulerOrigin.spreadOrigin;
 Dokument.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.strokeMeasurementUnits=MeasurementUnits.POINTS;
 //Počiatočné nastavenia podľa mriežky účiaria
 var MriezkaUciaria=Dokument.gridPreferences.baselineDivision;
 gZarazkyOdseku=MriezkaUciaria;
 var DialogMoznosti=app.dialogs.add({name:"Vodiace čiary zarážok odsekov"});
 with(DialogMoznosti){
  with(dialogColumns.add()){
   with(borderPanels.add()){
    with (dialogColumns.add()){
     staticTexts.add({staticLabel:"Odseková zarážka:"});
    }
    with (dialogColumns.add()){    
     //Veľkosť zarážky predpokladáme vo veľkosti mriežky účiaria
     var OdsekovaZarazkaField=measurementEditboxes.add({editValue:gZarazkyOdseku, editUnits:MeasurementUnits.POINTS});
    }
   }
  }
 }
 var aBodyNaPalec=app.activeDocument.viewPreferences.pointsPerInch; // Odpamätáme si terajšie nastavenie bodov na palec
 try
 {
  app.activeDocument.viewPreferences.pointsPerInch=72; // nastavíme americký systém 72 bodov na palec
 }
 catch (e)
 { 
  app.viewPreferences.pointsPerInch=72;
 }
 var DialogMoznostiOK=DialogMoznosti.show();
 //Nastavenie premenných z dialógu
 gZarazkyOdseku=OdsekovaZarazkaField.editValue;
 //Nastavenie povodnych hodnot
  try
 {
  app.activeDocument.viewPreferences.pointsPerInch=aBodyNaPalec; // nastavíme používateľský systém bodov na palec
 }
 catch (e)
 {
  app.viewPreferences.pointsPerInch=aBodyNaPalec;
 }
 Dokument.viewPreferences.rulerOrigin=PovodneNastavenia;
 Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 Dokument.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
 if (DialogMoznostiOK == true){
  DialogMoznosti.destroy();
  KresliOrezoveZnacky();
 }
 else{
  DialogMoznosti.destroy();
 }
}

function KresliOrezoveZnacky(){
 var Okraje, Objekt;
 var Dokument=app.activeDocument;
 //Odpamätanie pôvodných nastavení
 var PovodneNastavenia=Dokument.viewPreferences.rulerOrigin;
 var PovodnaXJednotka=Dokument.viewPreferences.horizontalMeasurementUnits;
 var PovodnaYJednotka=Dokument.viewPreferences.verticalMeasurementUnits;
 var PovodnaTahJednotka=app.viewPreferences.strokeMeasurementUnits;
 //Nastavenie jednotiek na pt
 Dokument.viewPreferences.rulerOrigin=RulerOrigin.spreadOrigin;
 Dokument.viewPreferences.horizontalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.verticalMeasurementUnits=MeasurementUnits.POINTS;
 Dokument.viewPreferences.strokeMeasurementUnits=MeasurementUnits.POINTS;
 //Vytvorenie vrstvy pre vodiace čiary (ak neexistuje)
 var VrstvaZarazkyOdseku=Dokument.layers.item("ZarazkyOdsekov");
 try{
  VrstvaZarazkyOdsekuName=VrstvaZarazkyOdseku.name;
 }
 catch (Chyba){
  var VrstvaZarazkyOdseku=Dokument.layers.add({name:"ZarazkyOdsekov"});
 }
 //Pre všetky vybrané objekty
 Okraje=Dokument.selection[0].visibleBounds;
 var VzorovaStranka=Dokument.masterSpreads.item(0);
 var NovyRamec;
 for(var KtoryObjekt=0; KtoryObjekt < Dokument.selection.length; KtoryObjekt ++){
  Objekt=Dokument.selection[KtoryObjekt];
  Okraje=Objekt.visibleBounds;
  if (gZarazkyOdseku != 0) {
   //Vykreslenie vodiacich čiar
   //Zvislé čiary (Orientacia=1)
   var LaveX=Okraje[1]+gZarazkyOdseku;
   var PraveX=Okraje[3]-gZarazkyOdseku;
   KresliVodiacuCiaru(LaveX, 1, VrstvaZarazkyOdseku);
   KresliVodiacuCiaru(PraveX, 1, VrstvaZarazkyOdseku);
  }
  Dokument.activeLayer=Dokument.layers.item(1); 
 }
 //Nastavenie povodnych hodnot
 Dokument.viewPreferences.rulerOrigin=PovodneNastavenia;
 Dokument.viewPreferences.horizontalMeasurementUnits=PovodnaXJednotka;
 Dokument.viewPreferences.verticalMeasurementUnits=PovodnaYJednotka;
 Dokument.viewPreferences.strokeMeasurementUnits=PovodnaTahJednotka;
}

function KresliVodiacuCiaru(Suradnica, Orientacia, VrstvaZarazkyOdseku){
 with(app.activeWindow.activeSpread){
  if(Orientacia == 0){
   with (guides.add(VrstvaZarazkyOdseku, undefined, undefined)){
    orientation=HorizontalOrVertical.horizontal;
    location=Suradnica;
   }
  }
  else{
   with (guides.add(VrstvaZarazkyOdseku, undefined, undefined)){
    orientation=HorizontalOrVertical.vertical;
    location=Suradnica;
   }
  }
 }
}
